; falcom BZH Extractor "BZHX.COM"
;  (for NASM)

		USE16
		CPU	186

		SEGMENT	CODE (class=code)

		ORG	0x0100

; x`
; -----------------
CR		equ	0x0d
LF		equ	0x0a
NL		equ	'$'
NULL		equ	0x00
TAB		equ	0x09

; sJn
; ============================================================================
start:		cld
		mov	ah,0x09		; N\
		mov	dx,title_msg
		int	0x21

		call	cmd_analyze
		call	mem_alloc	; m
		call	file_load
		mov	bx,[buffer_seg]
		push	ds
		push	es
		mov	ds,bx		; WJZOg
		xor	si,si		; WJItZbg
		add	bx,0x1000	; WJZOg
		xor	di,di		; WJItZbg

		cmp	byte [cs:decode_type],1	; k`}jAw
		jz	bzh_type1
		cmp	byte [cs:decode_type],2
		jz	bzh_type2
		cmp	word [si+2],0	; k`𔻒
		jnz	bzh_type2

bzh_type1:	call	extract		; WJ[`(1)
		jmp	short ext_ok
bzh_type2:	call	extract2	; WJ[`(2)

ext_ok:		mov	ax,es		; WJ̃TCY߂
		sub	bx,ax
		shl	bx,4
		add	bx,di		; [
		pop	es
		pop	ds
		mov	[extfilesize],bx
		call	file_save
		call	mem_free	; 

exit:		mov	ax,0x4c00	; I (code=0)
		int	0x21



; 蓖
; ============================================================================
mem_alloc:	mov	bx,0x1000	; 64KB
		mov	ah,0x4a	
		int	0x21		; 蓖ăk
		mov	ah,0x48
		mov	bx,0x3000	; WJobt@64KB + WJpobt@128KB
		int	0x21		; VɃm
		jc	mem_error
		mov	[buffer_seg],ax
		mov	bx,ax		; 蓖Ă[NA
		push	ds
		push	es
		mov	cx,3
mem_clear_loop:	push	ax
		push	cx
		mov	ds,bx
		mov	es,bx
		xor	ax,ax
		mov	si,ax
		mov	di,ax
		inc	di
		inc	di
		mov	cx,0x8000-4
		mov	[si],ax
		rep	movsw
		pop	cx
		pop	ax
		add	bh,0x10		; 64KB
		loop	mem_clear_loop
		pop	es
		pop	ds
		ret

mem_error:	mov	dx,err_msg1	; G[\
		mov	ah,0x09
		int	0x21
		mov	ax,0x4c01	; ُI (code=1)
		int	0x21

; 
; ============================================================================
mem_free:	push	es
		mov	ax,[buffer_seg]	; 
		mov	es,ax
		mov	ah,0x49
		int	0x21
		pop	es
		ret

; R}hC
; ============================================================================
cmd_analyze:	xor	bx,bx
		mov	bl,[0x0080]	; 擾
		or	bl,bl
		jz	usage		; Xy[XȂƂ
		mov	byte [bx+0x81],NULL	; I[NULL𖄂ߍ
		mov	si,0x0081
analyze_loop:	call	getchar
		cmp	al,'-'
		jz	getopt
		or	al,al		; t@C̎w肪ȂƂ
		jz	usage
		mov	[loadfilename],si
cmd_analyze_e:	ret

getopt:		inc	si
		call	getchar		; 1擾
		inc	si
		cmp	al,'1'		; IvV
		jb	analyze_loop
		cmp	al,'2'
		ja	analyze_loop
		sub	al,'0'
		mov	[decode_type],al	; fR[hʂۑ
		jmp	short analyze_loop

usage:		mov	dx,usage_msg	; g\ďI
		mov	ah,0x09
		int	0x21
		mov	ax,0x4cff
		int	0x21

; t@C[h
; ============================================================================

file_load:	mov	ax,0x3d00	; t@CI[v
		mov	dx,[loadfilename]
		int	0x21
		jc	err_ropen
		mov	[load_fh],ax	; t@Cnhۑ
		mov	bx,ax
		push	ds
		mov	ax,[buffer_seg]
		mov	ds,ax		; t@C[h
		xor	dx,dx
		mov	cx,0xffff
		mov	ah,0x3f
		int	0x21
		pop	ds
		jc	err_load
		mov	[bzhfilesize],ax
		mov	bx,[load_fh]	; t@CN[Y
		mov	ah,0x3e
		int	0x21
		ret

err_ropen:	mov	dx,err_msg2	; t@CȂG[
		mov	ah,0x09
		int	0x21
		call	mem_free	; 
		mov	ax,0x4c02	; ُI (code=2)
		int	0x21

err_load:	mov	dx,err_msg3	; t@C[h̃G[
		mov	ah,0x09
		int	0x21
		call	mem_free	; 
		mov	ax,0x4c02	; ُI (code=2)
		int	0x21

; t@CZ[u
; ============================================================================
file_save:	mov	si,[loadfilename]
		mov	di,savefilename
		mov	cx,255		; őt@C

.loop:		call	getchar
		call	getfilename
		call	makefilename

		mov	ah,0x3c		; t@C쐬
		mov	dx,savefilename
		xor	cx,cx		; t@C m[}
		int	0x21
		jc	err_wopen
		mov	[save_fh],ax	; t@Cnhۑ
		mov	bx,ax
		mov	cx,[extfilesize]
		xor	dx,dx
		push	ds
		mov	ax,[buffer_seg]
		add	ax,0x1000	; WJobt@
		mov	ds,ax
		mov	ah,0x40
		int	0x21		; t@Co
		pop	ds
		jc	err_save

		mov	ax,cs
		mov	ds,ax
		mov	bx,[save_fh]
		mov	ah,0x3e		; t@CN[Y
		int	0x21
		jc	err_save
		ret

err_wopen:	mov	dx,err_msg4
		mov	ah,0x09
		int	0x21
		call	mem_free	; 
		mov	ax,0x4c03	; ُI (code=3)
		int	0x21

err_save:	mov	dx,err_msg5
		mov	ah,0x09
		int	0x21
		call	mem_free	; 
		mov	ax,0x4c03	; ُI (code=3)
		int	0x21

err_overrun:	mov	dx,err_msg6	; R}hC
		mov	ah,0x09
		int	0x21
		call	mem_free	; 
		mov	ax,0x4c04	; ُI (code=4)
		int	0x21

; R}hC̃Xy[X/^uǂݔ΂
; ============================================================================
getchar:	lodsb
		cmp	al,' '
		jz	getchar
		cmp	al,TAB
		jz	getchar
		dec	si
		ret

; pX؂藎Ƃ
; ============================================================================

getfilename:	push	si
		push	cx
		xor	bp,bp		; 
		mov	cx,255		; `FbN镶
path_loop:	lodsb
		dec	cx		; `FbN
		jz	dml_not_found
		or	al,al		; ̍Ō
		jz	cml_end
		cmp	al,' '		; ؂
		jz	cml_end
		cmp	al,TAB
		jz	cml_end
		call	sjis_check	; SHIFT JIS1byte
		jnc	path_check
		inc	si		; 2byte߂ǂݔ΂
		jmp	short path_loop

path_check:	cmp	al,'\'		; pX̋؂
		jnz	path_loop

		mov	al,[si]		; Ōオ'\'ŏIP[X̃`FbN
		or	al,al
		jz	dml_not_found
		cmp	al,' '
		jz	dml_not_found
		cmp	al,TAB
		jz	dml_not_found
		mov	bp,si		; ŌɏoĂ'\'̎̈ʒuL
		jmp	path_loop

cml_end:	or	bp,bp		; ?
		jz	dml_not_found
		pop	cx
		pop	si		; X^bN킹
		mov	si,bp		; SIŌɌ'\'̎̈ʒuɍ킹
		ret

dml_not_found:	pop	cx
		pop	si		; Ȃ͂̂܂SIԂ
		ret

; o̓t@C쐬
; ============================================================================

makefilename:	mov	cx,255		; őt@C
make_loop:	lodsb
		or	al,al
		jz	replace_ext	; gqȂꍇ̏
		cmp	al,' '
		jz	replace_ext
		cmp	al,TAB
		jz	replace_ext
		call	sjis_check	; SHIFT JIS1byte
		jnc	ext_check
		inc	si		; 2byte߂ǂݔ΂
		jmp	make_loop
ext_check:	cmp	al,'.'		; gq̏
		jz	replace_ext
		stosb			; gq܂͏I[܂ł͂̂܂܃Rs[
		loop	make_loop
		jmp	short err_overrun

replace_ext:	mov	si,extension
		mov	cx,5		; ̊gq
		rep	movsb
		ret

; SHIFT-JIS1oCg߂̃`FbN
; ============================================================================
sjis_check:	or	al,al
		jns	not_sjis
		push	ax
		sub	al,0x20
		test	al,0x40
		pop	ax
		jz	not_sjis
		stc			; SJIS1byte߂ CY=1
		ret
not_sjis:	clc			; Ⴄꍇ CY=0
		ret

; WJ[`C (1)
; ============================================================================
extract:	mov	es,bx
		inc	si
		inc	si
		lodsw
		xchg	ah,al
		mov	bp,ax
		mov	dx,8

main_loop:	call	get_flag
		or	al,al
		jnz	next1

; ̂܂܏o
type_0:		movsb
		jmp	short main_loop

next1:		call	get_flag
		or	al,al
		jnz	next2

		lodsb
		xor	cx,cx
		mov	cl,al
		jmp	type_c

next2:		call	get_flag
		mov	ch,al
		shl	ch,1
		call	get_flag
		or	ch,al
		shl	ch,1
		call	get_flag
		or	ch,al
		shl	ch,1
		call	get_flag
		or	ch,al
		shl	ch,1
		call	get_flag
		or	ch,al
		lodsb
		mov	cl,al
		cmp	cx,1
		ja	type_c
		or	cx,cx
		jz	seg_adj_e

		call	get_flag
		mov	ah,al
		call	get_flag
		mov	cl,al
		shl	cl,1
		call	get_flag
		or	cl,al
		shl	cl,1
		call	get_flag
		or	cl,al
		shl	cl,1
		call	get_flag
		or	cl,al
		or	ah,ah
		jnz	type_a
		xor	ch,ch
		jmp	type_b

seg_adj_e:	jmp	seg_adj

; TYPE_A eAo(1)
type_a:		mov	ch,cl
		lodsb
		mov	cl,al

; TYPE_B eAo(2)
type_b:		add	cx,0x0e
		lodsb
		rep	stosb
		jmp	main_loop

; TYPE_C ߋɏoĂp^[Rs[
type_c:		push	bx
		mov	bx,cx
		mov	cx,2
		call	get_flag
		or	al,al
		jnz	type_c3
		inc	cx
		call	get_flag
		or	al,al
		jnz	type_c3
		inc	cx
		call	get_flag
		or	al,al
		jnz	type_c3
		inc	cx
		call	get_flag
		or	al,al
		jnz	type_c3
		call	get_flag
		or	al,al
		jnz	type_c2

type_c1:	lodsb
		mov	cl,al
		add	cx,0x0e
		jmp	type_c3

type_c2:	call	get_flag
		mov	cl,al
		shl	cl,1
		call	get_flag
		or	cl,al
		shl	cl,1
		call	get_flag
		or	cl,al
		add	cl,6

type_c3:	xchg	bx,si
		sub	si,di
		neg	si
		mov	ax,ds
		pop	ds
		rep	movsb
		mov	si,bx
		mov	bx,ds
		mov	ds,ax
		jmp	main_loop

; ZOg
seg_adj:	mov	ax,si
		shr	ax,4
		mov	bp,ds
		add	bp,ax
		mov	ds,bp
		and	si,0x0f
		mov	ax,di
		shr	ax,4
		add	bx,ax
		and	di,0x0f
		lodsb
		or	al,al
		jz	extract_end
		jmp	extract
extract_end:	ret

; tO擾
get_flag:	or	dx,dx
		jnz	next3

		mov	bp,[si]
		inc	si
		inc	si
		mov	dx,0x10

next3:		xor	al,al
		shr	bp,1
		rcl	al,1
		dec	dx
		ret

; WJ[`(2) C
; ============================================================================

extract2:	mov	dx,0x8040
ext2_start:	mov	es,bx
		mov	bp,si
		lodsw
		add	bp,ax

main_loop2:	cmp	si,bp
		jnz	next4
		jmp	seg_adj2

next4:		lodsb
		test	dh,al
		jnz	next8
		test	dl,al
		jnz	next6
		test	al,0x20
		jnz	next5

		xor	cx,cx
		mov	cl,al
		rep	movsb
		jmp	main_loop2

next5:		mov	ch,al
		lodsb
		mov	cl,al
		and	ch,0x1f
		rep	movsb
		jmp	main_loop2

next6:		test	al,0x10
		jnz	next7
		and	al,0x0f
		xor	cx,cx
		mov	cl,al
		add	cx,4
		lodsb
		rep	stosb
		jmp	main_loop2

next7:		mov	ch,al
		lodsb
		mov	cl,al
		and	ch,0x0f
		add	cx,4
		lodsb
		rep	stosb
		jmp	main_loop2

next8:		xor	cx,cx
		mov	cl,al
		and	cl,0x60
		rol	cl,3
		add	cl,4
		and	al,0x1f
		mov	ah,al
		lodsb
		xchg	ax,si
		sub	si,di
		neg	si
		push	ds
		mov	ds,bx
		rep	movsb
		pop	ds
		xchg	ax,si

.loop2:		cmp	si,bp
		jz	seg_adj2
		mov	cx,ax
		mov	al,[si]
		and	al,0xe0
		cmp	al,0x60
		jnz	main_loop2

		lodsb
		xchg	ax,cx
		xchg	ax,si
		xor	ch,ch
		and	cl,0x1f
		push	ds
		mov	ds,bx
		rep	movsb
		pop	ds
		xchg	ax,si
		jmp	.loop2

seg_adj2:	mov	ax,si		; ZOgړ
		shr	ax,4
		mov	bp,ds
		add	bp,ax
		mov	ds,bp
		and	si,0x0f
		mov	ax,di
		shr	ax,4
		add	bx,ax
		and	di,0x0f
		lodsb
		or	al,al
		jz	ext2_end
		jmp	ext2_start
ext2_end:	ret


; f[^/[N
; ============================================================================

title_msg:	db	'Falcom BZH File Extractor  BZHX.COM  version 0.2c',CR,LF,NL
usage_msg:	db	'Usage:  BZHX [-1|2] [bzh filename]',CR,LF
		db	'        -1 : k`1ƂēWJ܂.',CR,LF
		db	'        -2 : k`2ƂēWJ܂.',CR,LF
		db	'        o̓t@C͊gq .BIN ƂȂ܂.',CR,LF,NL

err_msg1:	db	'̊蓖Ăo܂.',CR,LF,NL
err_msg2:	db	't@C܂.',CR,LF,NL
err_msg3:	db	'ǂݍ݂Ɏs܂.',CR,LF,NL
err_msg4:	db	't@C߂܂.',CR,LF,NL
err_msg5:	db	'݂Ɏs܂.',CR,LF,NL
err_msg6:	db	'R}hC܂.',CR,LF,NL

extension:	db	'.BIN',NULL	; gq
loadfilename:	dw	0		; t@C̃|C^i[p
savefilename:	times 256 db 0x00	; Z[ut@C
load_fh:	dw	0		; [ht@C̃nh
save_fh:	dw	0		; Z[ut@C̃nh
buffer_seg:	dw	0		; mۂobt@̃ZOg
bzhfilesize:	dw	0		; WJÕt@CTCY
extfilesize:	dw	0		; WJ̃t@CTCY
decode_type:	db	0		; k`wp[N

code_end:
		ends

